// StudyHanjaMFC.cpp :  α׷  Ŭ  մϴ.
//

#include "stdafx.h"
#include "StudyHanjaMFC.h"
#include "StudyHanjaMFCDlg.h"
#include ".\studyhanjamfc.h"
#include "SetTimeDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CStudyHanjaMFCApp

BEGIN_MESSAGE_MAP(CStudyHanjaMFCApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
	ON_COMMAND(ID_QUIT, OnQuit)
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_COMMAND(ID_HIDE_CHAR, OnHideCharacter)
	ON_COMMAND(ID_HIDE_TALK, OnHideTalk)
	ON_COMMAND(ID_OPEN_WEBDIC, OnOpenWebdic)
	ON_COMMAND(ID_DIFF_EASE, OnDiffEase)
	ON_COMMAND(ID_DIFF_HARD, OnDiffHard)
	ON_COMMAND(ID_DIFF_MID, OnDiffMid)
	ON_COMMAND(ID_SET_TIMER, OnSetTimer)
	ON_COMMAND(ID_SET_TOPMOST, OnSetTopmost)
	ON_COMMAND(ID_WEB_FIND_TALK, OnWebFindTalk)
	ON_COMMAND(ID_WEB_FIND_MOUSE, OnWebFindMouse)
	ON_COMMAND(ID_SET_RANDOM, OnSetRandom)
END_MESSAGE_MAP()


// CStudyHanjaMFCApp 

CStudyHanjaMFCApp::CStudyHanjaMFCApp()
{
	// TODO: ⿡  ڵ带 ߰մϴ.
	// InitInstance  ߿ ʱȭ ۾ ġմϴ.
}


//  CStudyHanjaMFCApp üԴϴ.

CStudyHanjaMFCApp theApp;
CWebBrowser *m_pWebDlg;		// WebBrowser ޸ 
CRect moniterRect;			//  ü ũ
popmenu_config m_sConfig;

// CStudyHanjaMFCApp ʱȭ

BOOL CStudyHanjaMFCApp::InitInstance()
{
	//  α׷ Ŵ佺Ʈ ComCtl32.dll  6 ̻ Ͽ ־ Ÿ
	// ϵ ϴ , Windows XP 󿡼 ݵ InitCommonControls() ʿմϴ. 
	// InitCommonControls()   â   ϴ.
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// ǥ ʱȭ
	// ̵   ʰ    ũ⸦ ̷
	// Ʒ ʿ  Ư ʱȭ ƾ ؾ մϴ.
	// ش   Ʈ Ű Ͻʽÿ.
	// TODO:  ڿ ȸ Ǵ  ̸ 
	//   ؾ մϴ.
	m_pTalkDlg = NULL;
	m_pWebDlg = NULL;
	m_sConfig.m_bWebVisual = FALSE;
	
	// Ʈ 
	this->SetRegistryKey(L"Study for Japan Hanja");

	CStudyHanjaMFCDlg dlg;		// Character ȭ ü ̳ Main 
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	
	// ȭ ڰ Ƿ  α׷ ޽   ʰ
	//  α׷   ֵ FALSE ȯմϴ.
	
	return FALSE;
}

void CStudyHanjaMFCApp::OnQuit()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	::PostQuitMessage(1);
}

void CStudyHanjaMFCApp::OnAbout()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CDialog AboutDlg(IDD_ABOUT);
	switch(AboutDlg.DoModal())
	{
		case IDOK:
			AboutDlg.DestroyWindow();
			break;

		case IDOK2:
			::ShellExecute(NULL, L"open", L"http://rosagigantea.tistory.com/", NULL, NULL, SW_SHOWNORMAL);
			break;
	}
}

void CStudyHanjaMFCApp::OnHideCharacter()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	if(this->m_pMainWnd->IsWindowVisible())
	{
		this->m_pMainWnd->ShowWindow(SW_HIDE);
		m_sConfig.m_bCharHide = TRUE;
	}
	else
	{
		this->m_pMainWnd->ShowWindow(SW_SHOW);
		m_sConfig.m_bCharHide = FALSE;
	}
	AfxGetApp()->WriteProfileInt(L"Character",L"Hide",m_sConfig.m_bCharHide);
			
}

void CStudyHanjaMFCApp::OnHideTalk()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	if(m_pTalkDlg != NULL)
	{
		m_pTalkDlg->ShowWindow(SW_HIDE);
		m_pTalkDlg->DestroyWindow();
		m_pTalkDlg = NULL;

		m_sConfig.m_bTalkHide = TRUE;
	}
	else
	{
		m_pTalkDlg = new CTalk();
		m_pTalkDlg->Create(IDD_TALK);
		m_pTalkDlg->ShowWindow(SW_SHOW);

		m_sConfig.m_bTalkHide = FALSE;
	}
	AfxGetApp()->WriteProfileInt(L"Talk",L"Hide",m_sConfig.m_bTalkHide);
	
}

void CStudyHanjaMFCApp::OnOpenWebdic()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	m_pWebDlg = new CWebBrowser;
	m_pWebDlg->Create(IDD_WEBDIC);
	m_pWebDlg->ShowWindow(SW_SHOW);

	m_pWebDlg->m_WndBrowser.put_Width(430);
	m_pWebDlg->m_WndBrowser.put_Height(555);

	CString csURL = L"http://jpdic.naver.com/small.naver?where=index";
	m_pWebDlg->m_WndBrowser.Navigate(csURL,NULL,NULL,NULL,NULL);

	m_sConfig.m_bWebVisual = TRUE;
}

void CStudyHanjaMFCApp::OnWebFindTalk()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	if(m_sConfig.m_iWebFindSelect == 1)	// ̹  ¶
		m_sConfig.m_iWebFindSelect = 0;	// ʱȭ
	else
	{
		m_sConfig.m_iWebFindSelect = 1;

		if(m_pWebDlg->m_hmodHookTool != NULL)
			m_pWebDlg->HookDelete();
	}

	AfxGetApp()->WriteProfileInt(L"Talk",L"WebFind",m_sConfig.m_iWebFindSelect);
}

void CStudyHanjaMFCApp::OnWebFindMouse()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	if(m_sConfig.m_iWebFindSelect == 2)
	{
		m_sConfig.m_iWebFindSelect = 0;
		m_pWebDlg->HookDelete();
	}
	else
	{
		m_sConfig.m_iWebFindSelect = 2;
		if(!m_pWebDlg->StartUp())
		{
			m_sConfig.m_iWebFindSelect = 0;
			AfxMessageBox(L"ŷ ۵ ",MB_OK);
		}
	}
	AfxGetApp()->WriteProfileInt(L"Talk",L"WebFind",m_sConfig.m_iWebFindSelect);
}


void CStudyHanjaMFCApp::OnDiffEase()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	m_sConfig.m_iLevel = 2;
	AfxGetApp()->WriteProfileInt(L"Talk",L"Level",m_sConfig.m_iLevel);
}

void CStudyHanjaMFCApp::OnDiffMid()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	m_sConfig.m_iLevel = 1;
	AfxGetApp()->WriteProfileInt(L"Talk",L"Level",m_sConfig.m_iLevel);
}

void CStudyHanjaMFCApp::OnDiffHard()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	m_sConfig.m_iLevel = 0;
	AfxGetApp()->WriteProfileInt(L"Talk",L"Level",m_sConfig.m_iLevel);
}

void CStudyHanjaMFCApp::OnSetTimer()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CSetTimeDialog SetDlg;
	SetDlg.m_iSetTime = m_sConfig.m_iTime_Delay / 1000;
	if(SetDlg.DoModal() == IDOK)
	{
		m_sConfig.m_iTime_Delay = SetDlg.m_iSetTime*1000;

		m_pTalkDlg->KillTimer(100);
		m_pTalkDlg->SetTimer(100,m_sConfig.m_iTime_Delay,NULL);
		m_pTalkDlg->Invalidate();

		AfxGetApp()->WriteProfileInt(L"Talk",L"Time",m_sConfig.m_iTime_Delay);

		SetDlg.DestroyWindow();
	}
}

void CStudyHanjaMFCApp::OnSetTopmost()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	m_sConfig.m_bWindow_Top=!m_sConfig.m_bWindow_Top;
	::SetWindowPos(AfxGetMainWnd()->m_hWnd,(m_sConfig.m_bWindow_Top ? HWND_TOPMOST:HWND_NOTOPMOST),
		0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);

	AfxGetApp()->WriteProfileInt(L"Character",L"TopMost",m_sConfig.m_bWindow_Top);
}

void CStudyHanjaMFCApp::OnSetRandom()
{
	m_sConfig.m_bRandom = !m_sConfig.m_bRandom;
	
	m_pTalkDlg->Load_Dic();

	AfxGetApp()->WriteProfileInt(L"Talk",L"Random",m_sConfig.m_bRandom);
}

void PopMenu(CWnd *pWnd, CPoint point)
{
	CMenu m_lMenu;
	m_lMenu.LoadMenu(IDR_POPUP);

	CMenu *pMenu = m_lMenu.GetSubMenu(0);

	switch(m_sConfig.m_iLevel)					//  ̵ κ üũ ó .
	{
	case 0:
			CheckMenuItem(m_lMenu, ID_DIFF_HARD, MF_BYCOMMAND | MF_CHECKED);
		break;
	case 1:
			CheckMenuItem(m_lMenu, ID_DIFF_MID, MF_BYCOMMAND | MF_CHECKED);
		break;
	case 2:
			CheckMenuItem(m_lMenu, ID_DIFF_EASE, MF_BYCOMMAND | MF_CHECKED);
		break;
	}
	if(m_sConfig.m_bWindow_Top)
		CheckMenuItem(m_lMenu, ID_SET_TOPMOST, MF_BYCOMMAND | MF_CHECKED);
	
	if(m_sConfig.m_bRandom)
		CheckMenuItem(m_lMenu, ID_SET_RANDOM, MF_BYCOMMAND | MF_CHECKED);
	
	if(m_sConfig.m_bCharHide)
		CheckMenuItem(m_lMenu, ID_HIDE_CHAR, MF_BYCOMMAND | MF_CHECKED);

	if(m_sConfig.m_bTalkHide)
		CheckMenuItem(m_lMenu, ID_HIDE_TALK, MF_BYCOMMAND | MF_CHECKED);

	if(m_sConfig.m_bWebVisual)
	{
		EnableMenuItem(m_lMenu, ID_WEB_FIND_TALK, MF_ENABLED);
		// ̰ ŷ   Ŀ Ǯ..
		EnableMenuItem(m_lMenu, ID_WEB_FIND_MOUSE, MF_ENABLED);
	}
	else
	{
		EnableMenuItem(m_lMenu, ID_WEB_FIND_TALK, MF_GRAYED);
		EnableMenuItem(m_lMenu, ID_WEB_FIND_MOUSE, MF_GRAYED);
	}
	if(m_sConfig.m_iWebFindSelect == 1)
		CheckMenuItem(m_lMenu, ID_WEB_FIND_TALK, MF_BYCOMMAND | MF_CHECKED);

	if(m_sConfig.m_iWebFindSelect == 2)
		CheckMenuItem(m_lMenu, ID_WEB_FIND_MOUSE, MF_BYCOMMAND | MF_CHECKED);


    pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, pWnd, NULL);
}

/* Ŀ ̷ ٲ..   ȴ.
void CStudyHanjaMFCApp::OnUpdateDiffEase(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_iLevel == 2);
}

void CStudyHanjaMFCApp::OnUpdateDiffMid(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_iLevel == 1);
}

void CStudyHanjaMFCApp::OnUpdateDiffHard(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_iLevel == 0);
}

void CStudyHanjaMFCApp::OnUpdateSetTopmost(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_bWindow_Top);
}

void CStudyHanjaMFCApp::OnUpdateSetRandom(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_bRandom);
}

void CStudyHanjaMFCApp::OnUpdateHideChar(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_bCharHide);
}

void CStudyHanjaMFCApp::OnUpdateHideTalk(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_bTalkHide);
}

void CStudyHanjaMFCApp::OnUpdateWebFindTalk(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_iWebFindSelect == 1);
	pCmdUI->Enable(m_sConfig.m_bWebVisual = true);
}

void CStudyHanjaMFCApp::OnUpdateWebFindMouse(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sConfig.m_iWebFindSelect == 2);
	pCmdUI->Enable(m_sConfig.m_bWebVisual = true);
}

*/