// WebBrowser.cpp :  Դϴ.
//

#include "stdafx.h"
#include "StudyHanjaMFC.h"
#include "WebBrowser.h"
#include "IniFile.h"
#include ".\webbrowser.h"

// CWebBrowser ȭ Դϴ.

IMPLEMENT_DYNAMIC(CWebBrowser, CDialog)
CWebBrowser::CWebBrowser(CWnd* pParent /*=NULL*/)
	: CDialog(CWebBrowser::IDD, pParent)
{
}

CWebBrowser::~CWebBrowser()
{
}

void CWebBrowser::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EXPLORER, m_WndBrowser);
}


BEGIN_MESSAGE_MAP(CWebBrowser, CDialog)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_COPYDATA()
	ON_WM_DESTROY()
//	ON_WM_PAINT()
END_MESSAGE_MAP()


// CWebBrowser ޽ óԴϴ.

int CWebBrowser::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  ⿡ Ưȭ ۼ ڵ带 ߰մϴ.
	m_hmodHookTool = NULL;
	m_sConfig.m_iWebFindSelect = AfxGetApp()->GetProfileInt(L"Talk",L"WebFind",0);; //ʱⰪ
	
	if(m_sConfig.m_iWebFindSelect == 2)
	{
		if(!StartUp())
		{
			MessageBox(L"ŷ , ڵ ܾ ˻ ٲϴ.",L"...",MB_OK);
			m_sConfig.m_iWebFindSelect = 1;
		}
	}
	return 0;
}

void CWebBrowser::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_sConfig.m_bWebVisual = FALSE;
	OnOK();
}

BOOL CWebBrowser::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	if(m_sConfig.m_iWebFindSelect == 2)
	{
		SRECTEXT *psRecText;
		psRecText = (SRECTEXT*)pCopyDataStruct->lpData;
		
		if(psRecText != NULL)
		{
			CString strResult;// = psRecText->szResult;
	
			LPWSTR strTemp;
	        strTemp = SysAllocStringLen(NULL, 31);
			MultiByteToWideChar(CP_ACP, 0, psRecText->szResult, 31, strTemp, 31);
			strResult = strTemp;

			
			if(strResult.IsEmpty() == FALSE)
			{
				CString csURL;
				csURL.Format(L"http://jpdic.naver.com/small.naver?query=%s",strResult);
				m_pWebDlg->m_WndBrowser.Navigate(csURL,NULL,NULL,NULL,NULL);
			//	AfxMessageBox(strResult);
				
			}
			SysFreeString(strTemp); 
		}
	}
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}

void CWebBrowser::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	HookDelete();
}

bool CWebBrowser::StartUp()
{
	// API Hook ġ
	if(HookStart() == false)
	{
		::MessageBoxA(GetSafeHwnd(), "HookTool.Dll Ǵ DLL  Լ ε Ͽϴ.", "DLL ε ", MB_OK);
		MoveWindow(0, 0, 0, 0);
		PostQuitMessage(0);
		return false;
	}

	m_bStartHook = TRUE;
	m_nOSVersionType = GetOSVersionType();
	m_pfnInstallHook(this->m_hWnd, m_nOSVersionType);

	char szIniFile[MAX_PATH];
	m_pfnGetIniFilePath(szIniFile);
	CIniFile iniFile(szIniFile);

	return true;
}

bool CWebBrowser::HookStart()
{
	if (NULL == m_hmodHookTool)
	{
		m_hmodHookTool = ::LoadLibraryA( "HookTool.Dll" );
		if(m_hmodHookTool == NULL)
			return false;
		
		m_pfnInstallHook = (PFN_InstallHook)::GetProcAddress(m_hmodHookTool, "InstallHook");
		if(m_pfnInstallHook == NULL)
			return false;
		m_pfnUnInstallHook = (PFN_UnInstallHook)::GetProcAddress(m_hmodHookTool, "UnInstallHook");
		if(m_pfnUnInstallHook == NULL)
			return false;
		m_pfnSetHookOption = (PFN_SetHookOption)::GetProcAddress(m_hmodHookTool, "SetHookOption");
		if(m_pfnSetHookOption == NULL)	
			return false;
		m_pfnGetHookOption = (PFN_GetHookOption)::GetProcAddress(m_hmodHookTool, "GetHookOption");
		if(m_pfnGetHookOption == NULL)
			return false;
		m_pfnGetResultString = (PFN_GetResultString)::GetProcAddress(m_hmodHookTool, "GetResultString");
		if(m_pfnGetResultString == NULL)
			return false;
		m_pfnGetIniFilePath	= (PFN_GetIniFilePath)::GetProcAddress(m_hmodHookTool, "GetIniFilePath");
		if(m_pfnGetIniFilePath == NULL)
			return false;
		m_pfnSetEnabledRestart = (PFN_SetEnabledRestart)::GetProcAddress(m_hmodHookTool, "SetEnabledRestart");
		if(m_pfnSetEnabledRestart == NULL)
			return false;
	}
	return true;
}

void CWebBrowser::HookDelete()
{
	m_pfnUnInstallHook();	

	if (m_hmodHookTool)
		::FreeLibrary( m_hmodHookTool );
	
}


BOOL CWebBrowser::PreTranslateMessage(MSG* pMsg)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	if(pMsg->message == WM_KEYDOWN)
    {
        if(pMsg->wParam == VK_ESCAPE) return TRUE;
        if(pMsg->wParam == VK_RETURN) return TRUE;
    }	
	return CDialog::PreTranslateMessage(pMsg);
}
